routes/web.php
<?php

use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CountryController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::prefix('cms/admin')->group(function () {
    Route::view('/', 'cms.parent');
    Route::resource('categories', CategoryController::class);
    Route::resource('countries', CountryController::class);
});

app/Models/category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class category extends Model
{
    use HasFactory;
    
    protected $appends = ['visiblity_status'];
    public function getVisiblityStatusAttribute()
    {
        return $this->is_visible == 1 ? 'visible' : 'Hidden';
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\category;
use Illuminate\Auth\Events\Validated;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data = category::all();
        return response()->view('cms.categories.index', ['categories' => $data]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return response()->view('cms.categories.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        // dd($request->all());
        $request->validate([
            'name' => 'required|string|min:3|max:20',
            'desc' => 'nullable|string|min:3|max:50',
            'visible' => 'in:on|string'
        ], [
            'name.required' => 'Please , Enter category name !'
        ]);
        $category = new category();
        $category->name = $request->get('name');
        $category->description = $request->get('desc');
        $category->is_visible = $request->has('visible');
        $isSaved = $category->save();
        if ('isSaved') {
            session()->flash('type', 'success');
            session()->flash('message', 'Category saved successfulley');
            return redirect()->back();
            // return redirect()->route('categories.index');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\category  $category
     * @return \Illuminate\Http\Response
     */
    public function show(category $category)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(category $category)
    {
        return response()->view('cms.categories.edit', ['category' => $category]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, category $category)
    {
        $request->validate([
            'name' => 'required|string|min:3|max:20',
            'desc' => 'nullable|string|min:3|max:50',
            'visible' => 'in:on|string'
        ], [
            'name.required' => 'Please , Enter the new category name !'
        ]);
        $category->name = $request->get('name');
        $category->description = $request->get('desc');
        $category->is_visible = $request->has('visible');
        $isSaved = $category->save();
        if ($isSaved) {
            
            session()->flash('Umessage', "the category $category->id updated successfully");
            
            return redirect()->route('categories.index');
        } else
            return redirect()->back();
            // session()->flash('Umessage', 'danger');
            // session()->flash('type', 'danger');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(category $category)
    {
        $deleted = $category->delete();
        if ($deleted){
            return response()->json(['title'=>'Deleted successfully','icon'=>'success']);
        }
        else
            return response()->json(['title' => 'Deleted Failed', 'icon' => 'danger']);

        // if ($deleted) {
        //     return redirect()->back();
        }
    }

resources/views/cms/categories/create.blade.php
@extends('cms.parent')

@section('title','Categories')

@section('page-large-title','Categories')
@section('page-small-title','create')

@section('content')
    
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create Category</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="POST" action="{{route('categories.store')}}">
            @csrf   
                <div class="card-body">

                    @if ($errors->any())
                
                <div class="card-body">

                    <div class="alert alert-danger alert-dismissible">
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-ban"></i> Alert!</h5>
                        @foreach ($errors->all() as $error)
                            <li>{{$error}}</li>
                        @endforeach
                    </div> 
                        
                @endif
                @if (session()->has('message'))

                <div class="alert alert-success alert-dismissible">
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-check"></i> success!</h5>
                   {{session()->get('message')}}        {{-- {{session('message')}} --}}

                </div>
                    
                @endif

                


                  <div class="form-group">
                    <label for="name">Name</label>
                      
                    <input type="text" name="name" value="{{old('name')}}" class="form-control" id="name" placeholder="Enter Name">
                  </div>
                  <div class="form-group">
                    <label for="description">Description</label>
                    <input type="text" name="desc" value="{{old('desc')}}" class="form-control" id="description" placeholder="description">
                  </div>
                  
                  <div class="form-group">
                    <div class="custom-control custom-switch">
                      <input type="checkbox" name="visible"  class="custom-control-input" id="visible" checked>
                      <label class="custom-control-label" for="visible">visible</label>
                    </div>
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->

          </div>
          <!--/.col (left) -->
  
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('styles')
    
@endsection

@section('scripts')
    
@endsection

resources/views/cms/categories/edit.blade.php
@extends('cms.parent')

@section('title','Categories')

@section('page-large-title','Categories')
@section('page-small-title','update')

@section('content')
    
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">update Category</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="POST" action="{{route('categories.update',$category->id)}}">
            @csrf   
            @method('PUT')
                <div class="card-body">

                      @if ($errors->any())
                
                <div class="card-body">

                    <div class="alert alert-danger alert-dismissible">
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-ban"></i> Alert!</h5>
                        @foreach ($errors->all() as $error)
                            <li>{{$error}}</li>
                        @endforeach
                    </div> 
                        
                @endif
                @if (session()->has('Umessage'))

                 <div class="alert alert-success {{-- {{session()->get('type')}}   when we use it for many types like danger --}} alert-dismissible"> 
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-check"></i> success!</h5>
                   {{session()->get('Umessage')}}        {{-- {{session('Umessage')}} --}}

                </div>
                    
                @endif

                  <div class="form-group">
                    <label for="name">Name</label>
                      
                    <input type="text" name="name" @if (old('name')) value="{{old('name')}}" @else value="{{$category->name}}"  @endif   class="form-control" id="name" placeholder="Enter Name">
                  </div>
                  <div class="form-group">
                    <label for="description">Description</label>
                    <input type="text" name="desc" @if (old('desc')) value="{{old('desc')}}" @else value="{{$category->description}}"  @endif class="form-control" id="description" placeholder="description">
                  </div>
                  
                  <div class="form-group">
                    <div class="custom-control custom-switch">
                      <input type="checkbox" name="visible" @if ($category->is_visible) checked @endif class="custom-control-input" id="visible" >
                      <label class="custom-control-label" for="visible">visible</label>
                    </div>
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Update</button>
                </div>
              </form>
            </div>
            <!-- /.card -->

          </div>
          <!--/.col (left) -->
  
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('styles')
    
@endsection

@section('scripts')
    
@endsection

resources/views/cms/categories/index.blade.php
@extends('cms.parent')

@section('title','Categories')

@section('page-large-title','Categories')
@section('page-small-title','Index')

@section('content')
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-md-12">
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">Bordered Table</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                  @if (session()->has('Umessage'))

                     <div class="alert alert-success alert-dismissible">
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-check"></i> success!</h5>
                   {{session()->get('Umessage')}}        {{-- {{session('message')}} --}}

                    </div>
                      
                  @endif
                <table class="table table-bordered table-striped table-hover">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Name</th>
                      <th>Visible</th>
                      <th>Created At</th>
                      <th>Updated At</th>
                      <th>Settings</th>

                    </tr>
                  </thead>
                  <tbody>
                      @foreach ($categories as $category)
                          <tr>
                      <td>{{$category->id}}</td>
                      <td>{{$category->name}}</td>
                      <td>
                          <span class="badge @if($category->is_visible) bg-success @else bg-danger @endif ">{{$category->visiblity_status}}</span>
                          </td>
                      <td>{{$category->created_at->format('y-m-d H:ma')}}</td>
                      <td>{{$category->updated_at->format('y-m-d H:ma')}}</td>
                      <td>

                          <div class="btn-group">
                        <a href="{{route('categories.edit', $category->id)}}" class="btn btn-info">
                          <i class="fas fa-edit"></i>
                        </a>

                        <a onclick="deleteCategory({{$category->id}}, this)" class="btn btn-danger">
                          <i class="fas fa-trash"></i>
                        </a>

                         {{-- cms/admin/categories/{category} --}}
                        {{-- <form method="POST" action="{{route('categories.destroy',$category->id)}}">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger">
                          <i class="fas fa-trash"></i>
                        </button>
                        </form> --}}
                        
                        
                        </div>
                      </td>
                    </tr>
                 
                      @endforeach
                    
                  </tbody>
                </table>
              </div>
              
   
            </div>
            <!-- /.card -->

            <!-- /.card -->
          </div>
         
          <!-- /.col -->
        </div>
        
      </div><!-- /.container-fluid -->
    </section>
@endsection

@section('styles')
    
@endsection

@section('scripts')

    <script>
      function deleteCategory(id, raference){
        confirmDestroy('/cms/admin/categories',id, raference)
      }
        
    </script>
@endsection